require 'dry/schema'
require 'midnight/business_logic'

module Midnight
  module Rails
    class DryEvent < BusinessLogic::Event
      class SchemaViolation < BusinessLogic::Event::SchemaViolation
      end

      class << self
        private

        def ensure_schema(data)
          @data_schema ||= data_schema
          result = @data_schema.call(data)
          raise SchemaViolation unless result.success?
        end

        def data_schema
          raise NotImplementedError
          # example
          # ::Dry::Schema.Params do
          #   required(:example_field).filled(:string)
          # end
        end
      end
    end
  end
end
